<?php

/**
* Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */
 
namespace FiloBlu\Esb\Plugin\PrintDocument;
use \Magento\Sales\Api\Data\OrderInterface;
use \FiloBlu\Esb\Helper\Data;


/**
* Plugin that adds Print Document button.
 */

class Plugin{
	
    /**
     * @var \Magento\Framework\View\Element\AbstractBlock
     */  
	protected $_context;

    /**
     * @var \Magento\Sales\Api\OrderRepositoryInterface
     */  
	protected $_orderRepository;
	
    /**
     * @param \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
     */  
	public function __construct(
	        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
	    ){
		$this->_orderRepository=$orderRepository;
	}
	
    /**
     * Add Print Document Button
     *
     * @param \Magento\Backend\Block\Widget\Button\Toolbar $subject
     * @param \Magento\Framework\View\Element\AbstractBlock $context
     * @param \Magento\Backend\Block\Widget\Button\ButtonList $buttonList
     * @return void
     */
	public function beforePushButtons(
	        \Magento\Backend\Block\Widget\Button\Toolbar $subject,
	        \Magento\Framework\View\Element\AbstractBlock $context,
	        \Magento\Backend\Block\Widget\Button\ButtonList $buttonList
	    )
	    {
		$this->_context = $context;
		if ($context instanceof \Magento\Sales\Block\Adminhtml\Order\View) {
			$order=$this->_orderRepository->get($this->_context->getRequest()->getParam('order_id'));
			$invoices=$order->getInvoiceCollection();
			if(count($invoices) > 0){
                $invoice_id=$invoices->getFirstItem()->getId();
				$buttonList->add(
				                    'print_documents',
				                    [
				                        'label' => __('Print Documents'),
				                        'class' => 'primary',
				                        'onclick' => 'setLocation("' . $this->_context->getUrl('sales/order_invoice/print', ['invoice_id' => $invoice_id, 'redirect_path'=> 'order']) . '")',
				                    ]
				                );
			}
		}

	}
}
